QGIS Application - Bug report #11759
Python error when running "Import Vector into PostGIS database (available connections)
2014-11-28 09:47 AM - Filipe Dias

Status: Closed

Priority: Normal

Assignee: Giovanni Manghi

Category: Processing/GDAL

Affected QGIS version:master Regression?: No

Operating System: Easy fix?: No

Pull Request or Patch supplied: Resolution: fixed/implemented
Crashes QGIS or corrupls data: Copied to github as #: 19991
Description

When | try to run this algorithm, this message appears:

Algorithm Import Vector into PostGIS database (available connections) starting...
string index out of range See log for more details

Log:

Uncaught error while executing algorithm
Traceback (most recent call last):
Traceback (most recent call last):
File "/usr/share/qgis/python/plugins/processing/core/GeoAlgorithm.py", line 212, in execute
self.processAlgorithm(progress)
File "/usr/share/qgis/python/plugins/processing/algs/gdal/ogr2ogrtopostgislist.py”, line 252, in processAlgorithm
commands = ['ogr2ogr', GdalUtils.escapeAndJoin(arguments)]
File "/usr/share/qgis/python/plugins/processing/algs/gdal/GdalUtils.py", line 147, in escapeAndJoin
ifs2l="-"and"'"'ins:
IndexError: string index out of range

History

#1 - 2014-11-28 09:49 AM - Filipe Dias

The "Import Vector into PostGIS database (new connection)" works as expected

#2 - 2014-11-28 09:55 AM - Filipe Dias

- Subject changed from Python erro when running "Import Vector into PostGIS database (available connections)" to Python error when running "Import

Vector into PostGIS database (available connections)"

#3 - 2015-01-20 05:35 PM - Olivier Dalang

Confirmed here, but it's a bit strange since | get the error when trying on a remote postgis server, but not on the localhost... But none of them has spaces in

the database name nor in the password.

#4 - 2015-01-21 12:44 AM - Filipe Dias

The DB | tried with is also local and the name has no spaces or special characters.
#5 - 2015-01-21 04:49 AM - Giovanni Manghi
- Status changed from Open to Feedback

I'm not able to replicate the issue with my own local/remote connections, so | need more help in understanding what is the factor (what input) causing this

error.

#6 - 2015-01-22 08:21 AM - Giovanni Manghi

- Priority changed from High to Normal

#7 - 2015-01-22 10:53 AM - Filipe Dias

Olivier, I've sent Giovanni the details of my connection and he was not able to reproduce the bug. Can you provide more details on how you are

experiencing the bug?

#8 - 2015-01-22 12:37 PM - Pedro Venancio

Hi Filipe,

| also can not reproduce here (locally or remotely).

Can you share a sample dataset that is failing with you?

#9 - 2015-01-22 01:08 PM - Filipe Dias

- File points.tar.bz2 added

Thanks for taking the time to look at this.

| got this error with every shapefile | tried. I've attached an example.

#10 - 2015-01-23 04:05 AM - Giovanni Manghi

Filipe Dias wrote:

Thanks for taking the time to look at this.

| got this error with every shapefile | tried. I've attached an example.

please try on another pc, or just a VM.

#11 - 2015-01-23 04:18 AM - Pedro Venéancio

Filipe Dias wrote:

Thanks for taking the time to look at this.
| got this error with every shapefile | tried. I've attached an example.

Hi Filipe,

| tried on Xubuntu 12.04, Lubuntu 14.04 and Win OSGeo4W64, without problems.

#12 - 2015-01-25 11:53 PM - Jérome Guélat

Same problem here with a local PostGIS server (Windows 7, PostgreSQL 9.3.4, PostGIS 2.1.2, QGIS 2.7, 64-bit). However everything is fine with another

remote server running with Ubuntu...

#13 - 2015-01-26 02:03 AM - Pedro Venancio

Jérdme Guélat wrote:

Same problem here with a local PostGIS server (Windows 7, PostgreSQL 9.3.4, PostGIS 2.1.2, QGIS 2.7, 64-bit). However everything is fine with

another remote server running with Ubuntu...

Hi,

| don't know if that has some influence, but all database servers that I've tested are in Linux (one of them with PostgreSQL 9.1.14 and PostGIS 2.0.3).

#14 - 2015-01-26 02:10 AM - Filipe Dias

I'm on ubuntu 14.04, using Postgresql 9.3.5, Postgis 2.1.3

#15 - 2015-01-27 01:02 AM - Filipe Dias

| just tested this tool on Ubuntu 12.04 + postgresqgl 9.1.14 + postgis 2.1.3 (in the same computer, different partition) and got the same error.

#16 - 2015-01-27 01:33 AM - Filipe Dias

In my case the problem was the field "Database" was blank (in postgis connection properties). Once | filled it the tool worked as expected.

| understand this field is mandatory, but note that it is possible to import shapefiles into a Postgis DB using DB Manager with this field blank.

#17 - 2015-01-27 05:56 AM - Jérome Guélat
| think you found something interesting! The password field in the PostGIS connection properties was empty in my case (because | don't want a password

for local connections). The tool worked as expected as soon as | added some characters in the password field.

#18 - 2015-01-28 01:20 AM - Giovanni Manghi
- Priority changed from Normal to Low
- Status changed from Feedback to Open
This tool makes really sense only if ALL connection informations are filled, otherwise you need to use the other version, the one that allows you to fill the

connection data instead of using an already defined one. Sure | can try to catch this error and throw a message.

#19 - 2015-01-28 01:42 AM - Jérome Guélat

| agree with you about the database field, but | think an empty password field is nothing unusual if you configure PostgreSQL to accept local connections

without password. You could check if the password field is empty and then use some "fake" password which will be accepted anyway.

#20 - 2015-01-29 01:01 AM - Filipe Dias

This is tool is only available in QGIS Master and 3 different people have already stumbled upon this. It's therefore likely more people will encounter this bug
when QGIS 2.8 is released. | would suggest adding a clear warning to the help file or, as Giovanni says, try to catch this error and throw a warning.

This is tool is way too good and doesn't deserve to have users frustrated over a matter as simple as this.

#21 - 2015-01-30 03:52 AM - Giovanni Manghi
- Priority changed from Low to Normal

fixed with

https://github.com/qgis/QGIS/pull/1871

#22 - 2015-01-31 01:45 PM - Giovanni Manghi
- Status changed from Open to Closed
- Resolution set to fixed/implemented

Files

points.tar.bz2 155 KB 2015-01-22 Filipe Dias
